# Generated by Django 4.2.21 on 2025-06-16 18:03

import django.core.validators
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('system_settings', '0016_alter_emailconfiguration_options_and_more'),
    ]

    operations = [
        migrations.CreateModel(
            name='BrokerConfiguration',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('created_by', models.CharField(blank=True, max_length=255, null=True)),
                ('updated_by', models.CharField(blank=True, max_length=255, null=True)),
                ('broker_name', models.CharField(help_text="Internal broker identifier (e.g., 'mybroker')", max_length=255, unique=True)),
                ('company_display_name', models.CharField(help_text='Company name shown to clients', max_length=255)),
                ('logo_light_url', models.URLField(blank=True, help_text='Public URL for light theme logo')),
                ('logo_dark_url', models.URLField(blank=True, help_text='Public URL for dark theme logo')),
                ('favicon_light_url', models.URLField(blank=True, help_text='Public URL for light favicon')),
                ('favicon_dark_url', models.URLField(blank=True, help_text='Public URL for dark favicon')),
                ('support_email', models.EmailField(blank=True, help_text='Primary support email address', max_length=254)),
                ('support_phone', models.CharField(blank=True, help_text='Primary support phone number', max_length=50)),
                ('company_address', models.TextField(blank=True, help_text='Company address for emails and legal')),
                ('max_ib_levels', models.IntegerField(default=3, help_text='Maximum depth of IB hierarchy (1-10)', validators=[django.core.validators.MinValueValidator(1), django.core.validators.MaxValueValidator(10)])),
                ('max_active_clients_per_broker', models.IntegerField(blank=True, help_text='Maximum number of active clients (null for unlimited)', null=True, validators=[django.core.validators.MinValueValidator(0)])),
                ('primary_color', models.CharField(default='#007bff', help_text='Primary brand color (hex)', max_length=7)),
                ('secondary_color', models.CharField(default='#6c757d', help_text='Secondary brand color (hex)', max_length=7)),
                ('regulatory_region', models.CharField(blank=True, help_text="Regulatory jurisdiction (e.g., 'CySEC', 'FCA', 'ASIC')", max_length=100)),
                ('license_number', models.CharField(blank=True, help_text='Regulatory license number', max_length=100)),
                ('last_updated', models.DateTimeField(auto_now=True, help_text='Last time configuration was updated')),
            ],
            options={
                'verbose_name': 'Broker Configuration',
                'verbose_name_plural': 'Broker Configurations',
                'db_table': 'broker_configuration',
            },
        ),
    ]
